<template>
  <b-modal :active.sync="ouvert" :width="size" :on-cancel="close" :full-screen="fullScreen">
    <section class="mt-modal" :class="classModal">
      <button type="button" class="mt-close" @click="close">X</button>
      <slot></slot>
    </section>
  </b-modal>
</template>

<script>
export default {
  name: 'MtModal',
  props: {
    ouvert: {
      type: Boolean,
      default: false,
      required: true,
    },
    size: {
      type: [String, Number],
      default: 650,
    },
    fullScreen: {
      type: Boolean,
      default: false,
    },
    classModal: {
      type: String,
      default: '',
    },
  },
  methods: {
    close() {
      this.$emit('update:ouvert', false);
      this.$emit('close', false);
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

/deep/ {
  .modal-background {
    background-color: $mtmodal-background;
    backdrop-filter: blur(5px);
  }
  .is-secondary {
    box-shadow: 0 2px 3px -2px rgba(159, 159, 159, 0.5);
  }
  .is-primary {
    box-shadow: 0 2px 8px -2px rgba(159, 159, 159, 0.5);
  }

  .modal-close {
    display: none;
  }

  .mt-modal-align-center {
    display: flex;
    flex-direction: column;
    align-items: center;
  }

  .mt-modal-message {
    font-weight: 300;
    cursor: default;
    margin-bottom: 1.4em;
    color: $grey-dark;
    font-size: 1rem;
    text-align: center;

    &.align-self-strech {
      align-self: stretch;
      text-align: left;
    }
  }

  .mt-modal-titre {
    color: $primary;
    font-size: 1.125rem;
    margin-bottom: 1em;
    font-weight: bold;
    padding: 0 0.25em;

    &.mt-modal-titre-left {
      align-self: flex-start;
    }
    &.mt-modal-titre-right {
      align-self: flex-end;
    }
  }
}
.mt-modal {
  background-color: white;
  padding: 2.5rem 5vw;
  box-shadow: 0 8px 10px 1px rgba(138, 165, 255, 0.24), 0 3px 14px 2px rgba(138, 165, 255, 0.22),
    0 5px 5px -3px rgba(138, 165, 255, 0.4);
  border-radius: $border-radius;
  margin: 10px;
  position: relative;
}
.mt-close {
  font-size: 0;
  position: absolute;
  top: 1rem;
  right: 1rem;
  height: 20px;
  width: 20px;
  border-style: none;
  background-color: transparent;
  cursor: pointer;
  display: flex;
  align-items: center;
  justify-content: center;
  border-radius: 50%;

  &:hover {
    background-color: rgba(0, 0, 0, 0.25);
  }

  &:after,
  &:before {
    content: '';
    height: 14px;
    width: 2px;
    background-color: #808080;
    position: absolute;
  }
  &:after {
    transform: rotate(45deg);
  }
  &:before {
    transform: rotate(-45deg);
  }
}
.mt-modal-stretch /deep/ .mt-modal-message {
  text-align: left;
  align-self: stretch;
}
/deep/ .modal-content {
  overflow: unset;
}
</style>
